org.eclipse.january.dataset

## Class AbstractCompoundDataset

- java.lang.Object
- - org.eclipse.january.dataset.LazyDatasetBase
  - - org.eclipse.january.dataset.AbstractDataset
    - - org.eclipse.january.dataset.AbstractCompoundDataset

- All Implemented Interfaces:
    Serializable, CompoundDataset, Dataset, IDataset, ILazyDataset, IMetadataProvider, INameable
  Direct Known Subclasses:
    CompoundByteDataset, CompoundDoubleDataset, CompoundFloatDataset, CompoundIntegerDataset, CompoundLongDataset, CompoundShortDataset

      public abstract class AbstractCompoundDataset
      extends AbstractDataset
      implements CompoundDataset

  Generic container class for data that is compound in nature Each subclass has an array of compound types, items of this array are composed of primitive types Data items can be Complex, Vector, etc
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `isize`

    - ### Fields inherited from class org.eclipse.january.dataset.AbstractDataset

      `base, BLOCK_CLOSE, BLOCK_OPEN, odata, offset, size, stride, stringFormat`

    - ### Fields inherited from class org.eclipse.january.dataset.LazyDatasetBase

      `metadata, name, shape`

    - ### Fields inherited from interface org.eclipse.january.dataset.Dataset

      `ARRAYFLOAT32, ARRAYFLOAT64, ARRAYINT16, ARRAYINT32, ARRAYINT64, ARRAYINT8, ARRAYMUL, BOOL, COMPLEX, COMPLEX128, COMPLEX64, DATE, FLOAT, FLOAT32, FLOAT64, INT, INT16, INT32, INT64, INT8, OBJECT, RGB, RGB8, STRING`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractCompoundDataset()` Constructor required for serialisation.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IntegerDataset` | `argMax(int axis, boolean... ignoreInvalids)` Find indices of maximum values along given axis
    `IntegerDataset` | `argMin(int axis, boolean... ignoreInvalids)` Find indices of minimum values along given axis
    `CompoundDataset` | `cast(boolean repeat, int dtype, int isize)` Cast a dataset
    `CompoundDataset` | `cast(int dtype)` Cast a dataset
    `abstract AbstractCompoundDataset` | `clone()` Clone dataset
    `boolean` | `equals(Object obj)`
    `CompoundDataset` | `flatten()` Flatten shape
    `protected int` | `get1DIndex(int i)`
    `protected int` | `get1DIndex(int i, int j)`
    `protected int` | `get1DIndexFromShape(int[] n)`
    `boolean` | `getBoolean()` Get first item as a boolean.
    `boolean` | `getBoolean(int... pos)`
    `boolean` | `getBoolean(int i)` Get an item from given position as a boolean.
    `boolean` | `getBoolean(int i, int j)` Get an item from given position as a boolean.
    `CompoundDataset` | `getBroadcastView(int... broadcastShape)`
    `CompoundDataset` | `getBy1DIndex(IntegerDataset index)` This is modelled after the NumPy get item with an index dataset
    `CompoundDataset` | `getByBoolean(Dataset selection)` This is modelled after the NumPy get item with a condition specified by a boolean dataset
    `CompoundDataset` | `getByIndexes(Object... indexes)` This is modelled after the NumPy get item with an array of indexing objects
    `byte` | `getByte()` Get first item as a byte.
    `byte` | `getByte(int... pos)`
    `byte` | `getByte(int i)` Get an item from given position as a byte.
    `byte` | `getByte(int i, int j)` Get an item from given positionj as a byte.
    `protected StatisticsMetadata<double[]>` | `getCompoundStats()`
    `double` | `getDouble()` Get first item as a double.
    `double` | `getDouble(int... pos)`
    `double` | `getDouble(int i)` Get an item from given position as a double.
    `double` | `getDouble(int i, int j)` Get an item from given position as a double.
    `void` | `getDoubleArray(double[] darray)` Get first item as a double array
    `void` | `getDoubleArray(double[] darray, int... pos)` Get an item as a double array
    `void` | `getDoubleArray(double[] darray, int i)` Get an item as a double array
    `void` | `getDoubleArray(double[] darray, int i, int j)` Get an item as a double array
    `int` | `getElementsPerItem()`
    `double` | `getError(int... pos)` Get the error for a given position.
    `double` | `getError(int i)` Get the error for given position.
    `double` | `getError(int i, int j)` Get the error for given position.
    `double[]` | `getErrorArray(int... pos)` Get the error values for a single point in the dataset
    `double[]` | `getErrorArray(int i)` Get the error values for given position
    `double[]` | `getErrorArray(int i, int j)` Get the error values for given position
    `CompoundDataset` | `getErrors()` Get the errors, if any.
    `protected abstract double` | `getFirstValue()`
    `protected abstract double` | `getFirstValue(int... pos)`
    `protected abstract double` | `getFirstValue(int i)`
    `protected abstract double` | `getFirstValue(int i, int j)`
    `float` | `getFloat()` Get first item as a float.
    `float` | `getFloat(int... pos)`
    `float` | `getFloat(int i)` Get an item from given position as a float.
    `float` | `getFloat(int i, int j)` Get an item from given position as a float.
    `int` | `getInt()` Get first item as an int.
    `int` | `getInt(int... pos)`
    `int` | `getInt(int i)` Get an item from given position as an int.
    `int` | `getInt(int i, int j)` Get an item from given position as an int.
    `IndexIterator` | `getIterator(boolean withPosition)`
    `IndexIterator` | `getIterator(int element)` Get an iterator that picks out the chosen element from all items
    `long` | `getLong()` Get first item as a long.
    `long` | `getLong(int... pos)`
    `long` | `getLong(int i)` Get an item from given position as a long.
    `long` | `getLong(int i, int j)` Get an item from given position as a long.
    `short` | `getShort()` Get first item as a short.
    `short` | `getShort(int... pos)`
    `short` | `getShort(int i)` Get an item from given position as a short.
    `short` | `getShort(int i, int j)` Get an item from given position as a short.
    `CompoundDataset` | `getSlice(IMonitor mon, int[] start, int[] stop, int[] step)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(IMonitor mon, Slice... slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(IMonitor mon, SliceND slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(int[] start, int[] stop, int[] step)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(Slice... slice)` Get a slice of the dataset.
    `abstract AbstractCompoundDataset` | `getSlice(SliceIterator iterator)` Get a slice of the dataset.
    `CompoundDataset` | `getSlice(SliceND slice)` Get a slice of the dataset.
    `IndexIterator` | `getSliceIterator(SliceND slice)`
    `CompoundDataset` | `getSliceView(int[] start, int[] stop, int[] step)` Get a slice of the dataset.
    `CompoundDataset` | `getSliceView(Slice... slice)` Get a slice of the dataset.
    `CompoundDataset` | `getSliceView(SliceND slice)` Get a slice of the dataset.
    `CompoundDataset` | `getTransposedView(int... axes)` Permute copy of dataset's axes so that given order is old order:
    `Dataset` | `getUniqueItems()` Get unique items
    `abstract AbstractCompoundDataset` | `getView(boolean deepCopyMetadata)`
    `int` | `hashCode()`
    `CompoundDataset` | `ifloorDivide(Object o)` In-place floor division
    `protected IndexIterator` | `internalGetSliceIterator(SliceND slice)`
    `Number` | `max(boolean... ignoreInvalids)`
    `CompoundDataset` | `max(int axis, boolean... ignoreInvalids)`
    `double[]` | `maxItem()` Calculate maximum values of elements over all items in dataset
    `int[]` | `maxPos(boolean... ignoreNaNs)`
    `Object` | `mean(boolean... ignoreInvalids)`
    `CompoundDataset` | `mean(int axis, boolean... ignoreInvalids)`
    `Number` | `min(boolean... ignoreInvalids)`
    `CompoundDataset` | `min(int axis, boolean... ignoreInvalids)`
    `double[]` | `minItem()` Calculate minimum values of elements over all items in dataset
    `int[]` | `minPos(boolean... ignoreNaNs)`
    `CompoundDataset` | `peakToPeak(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `product(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `reshape(int... shape)` Returns new dataset with new shape but old data if possible, otherwise a copy is made
    `double` | `rootMeanSquare(boolean... ignoreInvalids)`
    `CompoundDataset` | `rootMeanSquare(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `setSlice(Object obj, int[] start, int[] stop, int[] step)` This is modelled after the NumPy array slice
    `CompoundDataset` | `setSlice(Object object, Slice... slice)` This is modelled after the NumPy array slice
    `CompoundDataset` | `sort(Integer axis)` In-place sort of dataset
    `CompoundDataset` | `squeeze()` Remove dimensions of 1 in shape of the dataset
    `CompoundDataset` | `squeeze(boolean onlyFromEnd)` Remove dimensions of 1 in shape of the dataset from ends only if true
    `CompoundDataset` | `squeezeEnds()` Remove dimensions of 1 from ends of shape of the dataset
    `CompoundDataset` | `stdDeviation(int axis)` Standard deviation is square root of the variance
    `CompoundDataset` | `stdDeviation(int axis, boolean isWholePopulation, boolean... ignoreInvalids)` Standard deviation is square root of the variance
    `Object` | `sum(boolean... ignoreInvalids)`
    `CompoundDataset` | `sum(int axis, boolean... ignoreInvalids)`
    `CompoundDataset` | `swapAxes(int axis1, int axis2)` Swap two axes in dataset
    `CompoundDataset` | `synchronizedCopy()` This is a synchronized version of the clone method
    `CompoundDataset` | `transpose(int... axes)` See `Dataset.getTransposedView(int...)`
    `double` | `variance(boolean isWholePopulation, boolean... ignoreInvalids)` The sample variance can be calculated in two ways: if the dataset is considered as the entire population then the sample variance is simply the second central moment:
    `CompoundDataset` | `variance(int axis)`
    `CompoundDataset` | `variance(int axis, boolean isWholePopulation, boolean... ignoreInvalids)`

    - ### Methods inherited from class org.eclipse.january.dataset.AbstractDataset

      `all, all, any, any, argMax, argMin, calcSteps, cast, cast, checkAxis, checkAxis, checkCompatibility, copy, copy, copyToView, count, count, count, createStrides, createStrides, createStrides, createStrides, fillData, get1DIndex, get1DIndexFromShape, getBooleanIterator, getBooleanIterator, getBuffer, getBufferLength, getDType, getElementClass, getError, getErrorBuffer, getFirst1DIndex, getIndices, getInternalSquaredError, getItemBytes, getIterator, getMaxLineLength, getNbytes, getNDPosition, getOffset, getPositionIterator, getRank, getRealPart, getRealView, getShape, getShapeRef, getSize, getSliceIterator, getSliceIteratorFromAxes, getStats, getStrides, getStringStats, hasFloatingPointElements, isCompatibleWith, isComplex, max, mean, min, overrideInternal, peakToPeak, peakToPeak, product, product, residual, residual, rootMeanSquare, setData, setErrorBuffer, setItemDirect, setMaxLineLength, setShape, setSlice, setStringFormat, stdDeviation, stdDeviation, stdDeviation, stdDeviation, sum, toString, toString, variance, variance, variance`

    - ### Methods inherited from class org.eclipse.january.dataset.LazyDatasetBase

      `addMetadata, checkPermutatedAxes, checkSliceND, clearMetadata, copyMetadata, copyMetadata, createFromSerializable, dirtyMetadata, findMetadataTypeSubInterfaces, getErrorMetadata, getFirstMetadata, getMetadata, getMetadata, getMetadataMap, getName, hasErrors, reshapeMetadata, restoreMetadata, setDirty, setErrors, setMetadata, setName, sliceMetadata, transposeMetadata`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.january.dataset.CompoundDataset

      `asNonCompoundDataset, copyElements, fill, getByteArray, getByteArray, getByteArray, getByteArray, getDoubleArray, getDoubleArray, getDoubleArray, getDoubleArray, getDoubleArrayAbs, getElements, getElementsView, getFloatArray, getFloatArray, getFloatArray, getFloatArray, getIntArray, getIntArray, getIntArray, getIntArray, getLongArray, getLongArray, getLongArray, getLongArray, getShortArray, getShortArray, getShortArray, getShortArray, iadd, idivide, ifloor, imultiply, ipower, iremainder, isubtract, setBy1DIndex, setByBoolean, setByIndexes, setElements, setSlice`

    - ### Methods inherited from interface org.eclipse.january.dataset.Dataset

      `all, all, any, any, argMax, argMin, cast, cast, checkAxis, checkCompatibility, containsInfs, containsInvalidNumbers, containsNans, copy, copy, copyItemsFromAxes, count, count, count, fillDataset, get1DIndex, getBooleanIterator, getBooleanIterator, getBuffer, getDType, getElementBooleanAbs, getElementDoubleAbs, getElementLongAbs, getError, getErrorBuffer, getIndices, getIterator, getNbytes, getNDPosition, getObject, getObject, getObject, getObjectAbs, getOffset, getPositionIterator, getRealPart, getRealView, getShapeRef, getSliceIterator, getSliceIteratorFromAxes, getStrides, getString, getString, getString, getStringAbs, hasFloatingPointElements, isCompatibleWith, isComplex, max, mean, min, overrideInternal, peakToPeak, peakToPeak, product, product, residual, residual, residual, rootMeanSquare, set, set, set, setDirty, setErrorBuffer, setItemsOnAxes, setObjectAbs, setSlice, stdDeviation, stdDeviation, stdDeviation, stdDeviation, sum, toString, variance, variance, variance`

    - ### Methods inherited from interface org.eclipse.january.dataset.IDataset

      `getItemBytes, getMetadata, getObject, getString, resize, set, setStringFormat`

    - ### Methods inherited from interface org.eclipse.january.dataset.ILazyDataset

      `addMetadata, clearMetadata, getElementClass, getRank, getShape, getSize, hasErrors, setErrors, setMetadata, setShape`

    - ### Methods inherited from interface org.eclipse.january.dataset.IMetadataProvider

      `getFirstMetadata, getMetadata`

    - ### Methods inherited from interface org.eclipse.january.INameable

      `getName, setName`

- - ### Field Detail

    - #### isize

          protected int isize

  - ### Constructor Detail

    - #### AbstractCompoundDataset

          public AbstractCompoundDataset()

      Constructor required for serialisation.

  - ### Method Detail

    - #### getElementsPerItem

          public int getElementsPerItem()

      Specified by:
        `getElementsPerItem` in interface `ILazyDataset`
      Overrides:
        `getElementsPerItem` in class `AbstractDataset`
      Returns:
        Number of elements per item

    - #### get1DIndex

          protected int get1DIndex(int i)

      Overrides:
        `get1DIndex` in class `AbstractDataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        the index on the data array corresponding to that location

    - #### get1DIndex

          protected int get1DIndex(int i,
                                   int j)

      Overrides:
        `get1DIndex` in class `AbstractDataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        the index on the data array corresponding to that location

    - #### get1DIndexFromShape

          protected int get1DIndexFromShape(int[] n)

      Overrides:
        `get1DIndexFromShape` in class `AbstractDataset`

    - #### getUniqueItems

          public Dataset getUniqueItems()

      Description copied from interface: `Dataset`
      Get unique items
      Specified by:
        `getUniqueItems` in interface `Dataset`
      Returns:
        a sorted dataset of unique items

    - #### getIterator

          public IndexIterator getIterator(boolean withPosition)

      Specified by:
        `getIterator` in interface `Dataset`
      Overrides:
        `getIterator` in class `AbstractDataset`
      Parameters:
        `withPosition` - set true if position is needed
      Returns:
        an IndexIterator tailored for this dataset

    - #### getIterator

          public IndexIterator getIterator(int element)

      Get an iterator that picks out the chosen element from all items
      Parameters:
        `element` - to choose
      Returns:
        an iterator

    - #### getSliceIterator

          public IndexIterator getSliceIterator(SliceND slice)

      Specified by:
        `getSliceIterator` in interface `Dataset`
      Overrides:
        `getSliceIterator` in class `AbstractDataset`
      Parameters:
        `slice` - an n-D slice
      Returns:
        an slice iterator that operates like an IndexIterator

    - #### internalGetSliceIterator

          protected IndexIterator internalGetSliceIterator(SliceND slice)

      Overrides:
        `internalGetSliceIterator` in class `AbstractDataset`
      Parameters:
        `slice` - to define iterator
      Returns:
        an slice iterator that operates like an IndexIterator

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `LazyDatasetBase`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractDataset`

    - #### cast

          public CompoundDataset cast(boolean repeat,
                                      int dtype,
                                      int isize)

      Description copied from interface: `Dataset`
      Cast a dataset
      Specified by:
        `cast` in interface `CompoundDataset`
      Specified by:
        `cast` in interface `Dataset`
      Overrides:
        `cast` in class `AbstractDataset`
      Parameters:
        `repeat` - if true, repeat elements over item
        `dtype` - dataset type
        `isize` - item size
      Returns:
        a converted dataset

    - #### cast

          public CompoundDataset cast(int dtype)

      Description copied from interface: `Dataset`
      Cast a dataset
      Specified by:
        `cast` in interface `CompoundDataset`
      Specified by:
        `cast` in interface `Dataset`
      Overrides:
        `cast` in class `AbstractDataset`
      Parameters:
        `dtype` - dataset type
      Returns:
        a converted dataset

    - #### clone

          public abstract AbstractCompoundDataset clone()

      Description copied from interface: `ILazyDataset`
      Clone dataset
      Specified by:
        `clone` in interface `CompoundDataset`
      Specified by:
        `clone` in interface `Dataset`
      Specified by:
        `clone` in interface `IDataset`
      Specified by:
        `clone` in interface `ILazyDataset`
      Specified by:
        `clone` in class `AbstractDataset`
      Returns:
        a (shallow) copy of dataset

    - #### flatten

          public CompoundDataset flatten()

      Description copied from interface: `Dataset`
      Flatten shape
      Specified by:
        `flatten` in interface `CompoundDataset`
      Specified by:
        `flatten` in interface `Dataset`
      Overrides:
        `flatten` in class `AbstractDataset`
      Returns:
        a flattened dataset which is a view if dataset is contiguous otherwise is a copy

    - #### getBy1DIndex

          public CompoundDataset getBy1DIndex(IntegerDataset index)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy get item with an index dataset
      Specified by:
        `getBy1DIndex` in interface `CompoundDataset`
      Specified by:
        `getBy1DIndex` in interface `Dataset`
      Overrides:
        `getBy1DIndex` in class `AbstractDataset`
      Parameters:
        `index` - an integer dataset
      Returns:
        The new selected dataset by indices

    - #### getByBoolean

          public CompoundDataset getByBoolean(Dataset selection)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy get item with a condition specified by a boolean dataset
      Specified by:
        `getByBoolean` in interface `CompoundDataset`
      Specified by:
        `getByBoolean` in interface `Dataset`
      Overrides:
        `getByBoolean` in class `AbstractDataset`
      Parameters:
        `selection` - a boolean dataset of same shape to use for selecting items
      Returns:
        The new selected dataset

    - #### getByIndexes

          public CompoundDataset getByIndexes(Object... indexes)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy get item with an array of indexing objects
      Specified by:
        `getByIndexes` in interface `CompoundDataset`
      Specified by:
        `getByIndexes` in interface `Dataset`
      Overrides:
        `getByIndexes` in class `AbstractDataset`
      Parameters:
        `indexes` - an array of integer dataset, boolean dataset, slices or null entries (same as full slices)
      Returns:
        The new selected dataset by index

    - #### getSlice

          public CompoundDataset getSlice(IMonitor mon,
                                          int[] start,
                                          int[] stop,
                                          int[] step)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `CompoundDataset`
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Overrides:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `mon` - can be null
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          public CompoundDataset getSlice(IMonitor mon,
                                          Slice... slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `CompoundDataset`
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Overrides:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `mon` - can be null
        `slice` - an array of slice objects (the array can be null or contain nulls)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          public CompoundDataset getSlice(IMonitor mon,
                                          SliceND slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `CompoundDataset`
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Overrides:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `mon` - can be null
        `slice` - an n-D slice
      Returns:
        The dataset of the sliced data

    - #### getSlice

          public CompoundDataset getSlice(int[] start,
                                          int[] stop,
                                          int[] step)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `CompoundDataset`
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `IDataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Overrides:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          public CompoundDataset getSlice(Slice... slice)

      Description copied from interface: `ILazyDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `CompoundDataset`
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `IDataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Overrides:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `slice` - an array of slice objects (the array can be null or contain nulls)
      Returns:
        The dataset of the sliced data

    - #### getSlice

          public CompoundDataset getSlice(SliceND slice)

      Description copied from class: `AbstractDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in interface `CompoundDataset`
      Specified by:
        `getSlice` in interface `Dataset`
      Specified by:
        `getSlice` in interface `IDataset`
      Specified by:
        `getSlice` in interface `ILazyDataset`
      Overrides:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `slice` - an n-D slice
      Returns:
        The dataset of the sliced data

    - #### getSlice

          public abstract AbstractCompoundDataset getSlice(SliceIterator iterator)

      Description copied from class: `AbstractDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `iterator` - Slice iterator
      Returns:
        The dataset of the sliced data

    - #### getSliceView

          public CompoundDataset getSliceView(int[] start,
                                              int[] stop,
                                              int[] step)

      Description copied from interface: `IDataset`
      Get a slice of the dataset. The returned dataset is a view on a selection of items
      Specified by:
        `getSliceView` in interface `CompoundDataset`
      Specified by:
        `getSliceView` in interface `Dataset`
      Specified by:
        `getSliceView` in interface `IDataset`
      Specified by:
        `getSliceView` in interface `ILazyDataset`
      Overrides:
        `getSliceView` in class `AbstractDataset`
      Parameters:
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Returns:
        The sliced view of a dataset

    - #### getSliceView

          public CompoundDataset getSliceView(Slice... slice)

      Description copied from interface: `IDataset`
      Get a slice of the dataset. The returned dataset is a view on a selection of items
      Specified by:
        `getSliceView` in interface `CompoundDataset`
      Specified by:
        `getSliceView` in interface `Dataset`
      Specified by:
        `getSliceView` in interface `IDataset`
      Specified by:
        `getSliceView` in interface `ILazyDataset`
      Overrides:
        `getSliceView` in class `AbstractDataset`
      Parameters:
        `slice` - an array of slice objects (the array can be null or contain nulls)
      Returns:
        The sliced view of a dataset

    - #### getSliceView

          public CompoundDataset getSliceView(SliceND slice)

      Description copied from class: `AbstractDataset`
      Get a slice of the dataset. The returned dataset is a view on a selection of items
      Specified by:
        `getSliceView` in interface `CompoundDataset`
      Specified by:
        `getSliceView` in interface `Dataset`
      Specified by:
        `getSliceView` in interface `IDataset`
      Specified by:
        `getSliceView` in interface `ILazyDataset`
      Overrides:
        `getSliceView` in class `AbstractDataset`
      Parameters:
        `slice` - an n-D slice
      Returns:
        slice view

    - #### getTransposedView

          public CompoundDataset getTransposedView(int... axes)

      Description copied from interface: `IDataset`
      Permute copy of dataset's axes so that given order is old order:

            axisPerm = (p(0), p(1),...) => newdata(n(0), n(1),...) = olddata(o(0), o(1), ...)
            such that n(i) = o(p(i)) for all i

      I.e. for a 3D dataset (1,0,2) implies the new dataset has its 1st dimension running along the old dataset's 2nd dimension and the new 2nd is the old 1st. The 3rd dimension is left unchanged.
      Specified by:
        `getTransposedView` in interface `CompoundDataset`
      Specified by:
        `getTransposedView` in interface `Dataset`
      Specified by:
        `getTransposedView` in interface `IDataset`
      Specified by:
        `getTransposedView` in interface `ILazyDataset`
      Overrides:
        `getTransposedView` in class `AbstractDataset`
      Parameters:
        `axes` - if zero length then axes order reversed
      Returns:
        remapped view of data

    - #### getView

          public abstract AbstractCompoundDataset getView(boolean deepCopyMetadata)

      Specified by:
        `getView` in interface `CompoundDataset`
      Specified by:
        `getView` in interface `Dataset`
      Specified by:
        `getView` in class `AbstractDataset`
      Parameters:
        `deepCopyMetadata` - if true then deep-copy metadata
      Returns:
        whole view of dataset (i.e. data buffer is shared)

    - #### getBroadcastView

          public CompoundDataset getBroadcastView(int... broadcastShape)

      Specified by:
        `getBroadcastView` in interface `CompoundDataset`
      Specified by:
        `getBroadcastView` in interface `Dataset`
      Overrides:
        `getBroadcastView` in class `AbstractDataset`
      Parameters:
        `broadcastShape` - to use for broadcast
      Returns:
        view of dataset that is broadcasted to given shape

    - #### ifloorDivide

          public CompoundDataset ifloorDivide(Object o)

      Description copied from interface: `Dataset`
      In-place floor division
      Specified by:
        `ifloorDivide` in interface `CompoundDataset`
      Specified by:
        `ifloorDivide` in interface `Dataset`
      Overrides:
        `ifloorDivide` in class `AbstractDataset`
      Parameters:
        `o` - object to use
      Returns:
        dividend dataset

    - #### reshape

          public CompoundDataset reshape(int... shape)

      Description copied from interface: `Dataset`
      Returns new dataset with new shape but old data if possible, otherwise a copy is made
      Specified by:
        `reshape` in interface `CompoundDataset`
      Specified by:
        `reshape` in interface `Dataset`
      Overrides:
        `reshape` in class `AbstractDataset`
      Parameters:
        `shape` - new shape
      Returns:
        reshaped dataset

    - #### setSlice

          public CompoundDataset setSlice(Object obj,
                                          int[] start,
                                          int[] stop,
                                          int[] step)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy array slice
      Specified by:
        `setSlice` in interface `CompoundDataset`
      Specified by:
        `setSlice` in interface `Dataset`
      Overrides:
        `setSlice` in class `AbstractDataset`
      Parameters:
        `obj` - specifies the object used to set the specified slice
        `start` - specifies the starting indexes
        `stop` - specifies the stopping indexes (nb, these are not included in the slice)
        `step` - specifies the steps in the slice
      Returns:
        this

    - #### setSlice

          public CompoundDataset setSlice(Object object,
                                          Slice... slice)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy array slice
      Specified by:
        `setSlice` in interface `CompoundDataset`
      Specified by:
        `setSlice` in interface `Dataset`
      Overrides:
        `setSlice` in class `AbstractDataset`
      Parameters:
        `object` - specifies the object used to set the specified slice
        `slice` - destination where items of obj are set
      Returns:
        this

    - #### sort

          public CompoundDataset sort(Integer axis)

      Description copied from interface: `Dataset`
      In-place sort of dataset
      Specified by:
        `sort` in interface `CompoundDataset`
      Specified by:
        `sort` in interface `Dataset`
      Parameters:
        `axis` - to sort along. If null, then the flattened view is sorted
      Returns:
        sorted dataset

    - #### squeezeEnds

          public CompoundDataset squeezeEnds()

      Description copied from interface: `ILazyDataset`
      Remove dimensions of 1 from ends of shape of the dataset
      Specified by:
        `squeezeEnds` in interface `CompoundDataset`
      Specified by:
        `squeezeEnds` in interface `Dataset`
      Specified by:
        `squeezeEnds` in interface `IDataset`
      Specified by:
        `squeezeEnds` in interface `ILazyDataset`
      Overrides:
        `squeezeEnds` in class `AbstractDataset`
      Returns:
        this

    - #### squeeze

          public CompoundDataset squeeze()

      Description copied from interface: `IDataset`
      Remove dimensions of 1 in shape of the dataset
      Specified by:
        `squeeze` in interface `CompoundDataset`
      Specified by:
        `squeeze` in interface `Dataset`
      Specified by:
        `squeeze` in interface `IDataset`
      Overrides:
        `squeeze` in class `AbstractDataset`
      Returns:
        this

    - #### squeeze

          public CompoundDataset squeeze(boolean onlyFromEnd)

      Description copied from interface: `IDataset`
      Remove dimensions of 1 in shape of the dataset from ends only if true
      Specified by:
        `squeeze` in interface `CompoundDataset`
      Specified by:
        `squeeze` in interface `Dataset`
      Specified by:
        `squeeze` in interface `IDataset`
      Overrides:
        `squeeze` in class `AbstractDataset`
      Parameters:
        `onlyFromEnd` - if true, trim ends
      Returns:
        this

    - #### swapAxes

          public CompoundDataset swapAxes(int axis1,
                                          int axis2)

      Description copied from interface: `Dataset`
      Swap two axes in dataset
      Specified by:
        `swapAxes` in interface `CompoundDataset`
      Specified by:
        `swapAxes` in interface `Dataset`
      Overrides:
        `swapAxes` in class `AbstractDataset`
      Parameters:
        `axis1` - to swap
        `axis2` - to swap
      Returns:
        swapped view of dataset

    - #### synchronizedCopy

          public CompoundDataset synchronizedCopy()

      Description copied from interface: `Dataset`
      This is a synchronized version of the clone method
      Specified by:
        `synchronizedCopy` in interface `CompoundDataset`
      Specified by:
        `synchronizedCopy` in interface `Dataset`
      Overrides:
        `synchronizedCopy` in class `AbstractDataset`
      Returns:
        a copy of dataset

    - #### transpose

          public CompoundDataset transpose(int... axes)

      Description copied from interface: `Dataset`
      See `Dataset.getTransposedView(int...)`
      Specified by:
        `transpose` in interface `CompoundDataset`
      Specified by:
        `transpose` in interface `Dataset`
      Overrides:
        `transpose` in class `AbstractDataset`
      Parameters:
        `axes` - if zero length then axes order reversed
      Returns:
        remapped copy of data

    - #### getFirstValue

          protected abstract double getFirstValue()

      Returns:
        first value
      Since:
        2.0

    - #### getFirstValue

          protected abstract double getFirstValue(int i)

    - #### getFirstValue

          protected abstract double getFirstValue(int i,
                                                  int j)

    - #### getFirstValue

          protected abstract double getFirstValue(int... pos)

    - #### getBoolean

          public boolean getBoolean()

      Description copied from interface: `Dataset`
      Get first item as a boolean. The dataset must not be null
      Specified by:
        `getBoolean` in interface `Dataset`
      Returns:
        item

    - #### getBoolean

          public boolean getBoolean(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a boolean. The dataset must be 1D
      Specified by:
        `getBoolean` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getBoolean

          public boolean getBoolean(int i,
                                    int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a boolean. The dataset must be 2D
      Specified by:
        `getBoolean` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getBoolean

          public boolean getBoolean(int... pos)

      Specified by:
        `getBoolean` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as a boolean

    - #### getByte

          public byte getByte()

      Description copied from interface: `Dataset`
      Get first item as a byte. The dataset must not be null
      Specified by:
        `getByte` in interface `Dataset`
      Returns:
        item

    - #### getByte

          public byte getByte(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a byte. The dataset must be 1D
      Specified by:
        `getByte` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getByte

          public byte getByte(int i,
                              int j)

      Description copied from interface: `Dataset`
      Get an item from given positionj as a byte. The dataset must be 2D
      Specified by:
        `getByte` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getByte

          public byte getByte(int... pos)

      Specified by:
        `getByte` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as a byte

    - #### getShort

          public short getShort()

      Description copied from interface: `Dataset`
      Get first item as a short. The dataset must not be null
      Specified by:
        `getShort` in interface `Dataset`
      Returns:
        item

    - #### getShort

          public short getShort(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a short. The dataset must be 1D
      Specified by:
        `getShort` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getShort

          public short getShort(int i,
                                int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a short. The dataset must be 2D
      Specified by:
        `getShort` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getShort

          public short getShort(int... pos)

      Specified by:
        `getShort` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as a short

    - #### getInt

          public int getInt()

      Description copied from interface: `Dataset`
      Get first item as an int. The dataset must not be null
      Specified by:
        `getInt` in interface `Dataset`
      Returns:
        item

    - #### getInt

          public int getInt(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as an int. The dataset must be 1D
      Specified by:
        `getInt` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getInt

          public int getInt(int i,
                            int j)

      Description copied from interface: `Dataset`
      Get an item from given position as an int. The dataset must be 2D
      Specified by:
        `getInt` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getInt

          public int getInt(int... pos)

      Specified by:
        `getInt` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as an int

    - #### getLong

          public long getLong()

      Description copied from interface: `Dataset`
      Get first item as a long. The dataset must not be null
      Specified by:
        `getLong` in interface `Dataset`
      Returns:
        item

    - #### getLong

          public long getLong(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a long. The dataset must be 1D
      Specified by:
        `getLong` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getLong

          public long getLong(int i,
                              int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a long. The dataset must be 2D
      Specified by:
        `getLong` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getLong

          public long getLong(int... pos)

      Specified by:
        `getLong` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as a long

    - #### getFloat

          public float getFloat()

      Description copied from interface: `Dataset`
      Get first item as a float. The dataset must not be null
      Specified by:
        `getFloat` in interface `Dataset`
      Returns:
        item

    - #### getFloat

          public float getFloat(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a float. The dataset must be 1D
      Specified by:
        `getFloat` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getFloat

          public float getFloat(int i,
                                int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a float. The dataset must be 2D
      Specified by:
        `getFloat` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getFloat

          public float getFloat(int... pos)

      Specified by:
        `getFloat` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as a float

    - #### getDouble

          public double getDouble()

      Description copied from interface: `Dataset`
      Get first item as a double. The dataset must not be null
      Specified by:
        `getDouble` in interface `Dataset`
      Returns:
        item

    - #### getDouble

          public double getDouble(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a double. The dataset must be 1D
      Specified by:
        `getDouble` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getDouble

          public double getDouble(int i,
                                  int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a double. The dataset must be 2D
      Specified by:
        `getDouble` in interface `Dataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getDouble

          public double getDouble(int... pos)

      Specified by:
        `getDouble` in interface `IDataset`
      Parameters:
        `pos` - position
      Returns:
        Item in given position as a double

    - #### getDoubleArray

          public void getDoubleArray(double[] darray)

      Description copied from interface: `CompoundDataset`
      Get first item as a double array
      Specified by:
        `getDoubleArray` in interface `CompoundDataset`
      Parameters:
        `darray` - double array must be allocated and have sufficient length

    - #### getDoubleArray

          public void getDoubleArray(double[] darray,
                                     int i)

      Description copied from interface: `CompoundDataset`
      Get an item as a double array
      Specified by:
        `getDoubleArray` in interface `CompoundDataset`
      Parameters:
        `darray` - double array must be allocated and have sufficient length
        `i` - position in first dimension

    - #### getDoubleArray

          public void getDoubleArray(double[] darray,
                                     int i,
                                     int j)

      Description copied from interface: `CompoundDataset`
      Get an item as a double array
      Specified by:
        `getDoubleArray` in interface `CompoundDataset`
      Parameters:
        `darray` - double array must be allocated and have sufficient length
        `i` - position in first dimension
        `j` - position in second dimension

    - #### getDoubleArray

          public void getDoubleArray(double[] darray,
                                     int... pos)

      Description copied from interface: `CompoundDataset`
      Get an item as a double array
      Specified by:
        `getDoubleArray` in interface `CompoundDataset`
      Parameters:
        `darray` - double array must be allocated and have sufficient length
        `pos` - position

    - #### getCompoundStats

          protected StatisticsMetadata<double[]> getCompoundStats()

      Returns:
        statistics metadata
      Since:
        2.0

    - #### argMax

          public IntegerDataset argMax(int axis,
                                       boolean... ignoreInvalids)

      Description copied from interface: `Dataset`
      Find indices of maximum values along given axis
      Specified by:
        `argMax` in interface `Dataset`
      Overrides:
        `argMax` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        index dataset

    - #### argMin

          public IntegerDataset argMin(int axis,
                                       boolean... ignoreInvalids)

      Description copied from interface: `Dataset`
      Find indices of minimum values along given axis
      Specified by:
        `argMin` in interface `Dataset`
      Overrides:
        `argMin` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        index dataset

    - #### max

          public Number max(boolean... ignoreInvalids)

      Specified by:
        `max` in interface `IDataset`
      Overrides:
        `max` in class `AbstractDataset`
      Parameters:
        `ignoreInvalids` - - Can be null, empty, or one or more booleans. By default, all booleans are false. If the first boolean is true, will ignore NaNs and ignore infinities. Use the second boolean to ignore infinities separately.
      Returns:
        Maximum value

    - #### max

          public CompoundDataset max(int axis,
                                     boolean... ignoreInvalids)

      Specified by:
        `max` in interface `CompoundDataset`
      Specified by:
        `max` in interface `Dataset`
      Overrides:
        `max` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce over
        `ignoreInvalids` - - Can be null, empty, or one or more booleans. By default, all booleans are false. If the first boolean is true, will ignore NaNs and ignore infinities. Use the second boolean to ignore infinities separately.
      Returns:
        maxima along axis in dataset

    - #### min

          public Number min(boolean... ignoreInvalids)

      Specified by:
        `min` in interface `IDataset`
      Overrides:
        `min` in class `AbstractDataset`
      Parameters:
        `ignoreInvalids` - - see `IDataset.max(boolean...)`
      Returns:
        Minimum value

    - #### min

          public CompoundDataset min(int axis,
                                     boolean... ignoreInvalids)

      Specified by:
        `min` in interface `CompoundDataset`
      Specified by:
        `min` in interface `Dataset`
      Overrides:
        `min` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        minima along axis in dataset

    - #### maxPos

          public int[] maxPos(boolean... ignoreNaNs)

      Specified by:
        `maxPos` in interface `IDataset`
      Parameters:
        `ignoreNaNs` - - see `IDataset.max(boolean...)`
      Returns:
        Position of maximum value (or first position if there are more than one)

    - #### minPos

          public int[] minPos(boolean... ignoreNaNs)

      Specified by:
        `minPos` in interface `IDataset`
      Parameters:
        `ignoreNaNs` - - see `IDataset.max(boolean...)`
      Returns:
        Position of minimum value (or first position if there are more than one)

    - #### peakToPeak

          public CompoundDataset peakToPeak(int axis,
                                            boolean... ignoreInvalids)

      Specified by:
        `peakToPeak` in interface `CompoundDataset`
      Specified by:
        `peakToPeak` in interface `Dataset`
      Overrides:
        `peakToPeak` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        peak-to-peak dataset, the difference of maxima and minima of dataset along axis

    - #### maxItem

          public double[] maxItem()

      Description copied from interface: `CompoundDataset`
      Calculate maximum values of elements over all items in dataset
      Specified by:
        `maxItem` in interface `CompoundDataset`
      Returns:
        double array of element-wise maxima

    - #### minItem

          public double[] minItem()

      Description copied from interface: `CompoundDataset`
      Calculate minimum values of elements over all items in dataset
      Specified by:
        `minItem` in interface `CompoundDataset`
      Returns:
        double array of element-wise minima

    - #### mean

          public Object mean(boolean... ignoreInvalids)

      Specified by:
        `mean` in interface `IDataset`
      Overrides:
        `mean` in class `AbstractDataset`
      Parameters:
        `ignoreInvalids` - - see `IDataset.max(boolean...)`
      Returns:
        mean of all items in dataset as a double, array of doubles or a complex number

    - #### mean

          public CompoundDataset mean(int axis,
                                      boolean... ignoreInvalids)

      Specified by:
        `mean` in interface `CompoundDataset`
      Specified by:
        `mean` in interface `Dataset`
      Overrides:
        `mean` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        mean along axis in dataset

    - #### product

          public CompoundDataset product(int axis,
                                         boolean... ignoreInvalids)

      Specified by:
        `product` in interface `CompoundDataset`
      Specified by:
        `product` in interface `Dataset`
      Overrides:
        `product` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        product along axis in dataset

    - #### rootMeanSquare

          public CompoundDataset rootMeanSquare(int axis,
                                                boolean... ignoreInvalids)

      Specified by:
        `rootMeanSquare` in interface `CompoundDataset`
      Specified by:
        `rootMeanSquare` in interface `Dataset`
      Overrides:
        `rootMeanSquare` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        root mean square along axis in dataset

    - #### stdDeviation

          public CompoundDataset stdDeviation(int axis)

      Description copied from interface: `Dataset`
      Standard deviation is square root of the variance
      Specified by:
        `stdDeviation` in interface `CompoundDataset`
      Specified by:
        `stdDeviation` in interface `Dataset`
      Overrides:
        `stdDeviation` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
      Returns:
        standard deviation along axis in dataset
      See Also:
        `with isWholePopulation = false`

    - #### stdDeviation

          public CompoundDataset stdDeviation(int axis,
                                              boolean isWholePopulation,
                                              boolean... ignoreInvalids)

      Description copied from interface: `Dataset`
      Standard deviation is square root of the variance
      Specified by:
        `stdDeviation` in interface `CompoundDataset`
      Specified by:
        `stdDeviation` in interface `Dataset`
      Overrides:
        `stdDeviation` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `isWholePopulation` - if false, consider as sample of population
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        standard deviation along axis in dataset

    - #### sum

          public Object sum(boolean... ignoreInvalids)

      Specified by:
        `sum` in interface `Dataset`
      Overrides:
        `sum` in class `AbstractDataset`
      Parameters:
        `ignoreInvalids` - - see `IDataset.max(boolean...)`
      Returns:
        sum over all items in dataset as a Double, array of doubles or a complex number

    - #### sum

          public CompoundDataset sum(int axis,
                                     boolean... ignoreInvalids)

      Specified by:
        `sum` in interface `CompoundDataset`
      Specified by:
        `sum` in interface `Dataset`
      Overrides:
        `sum` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        sum along axis in dataset

    - #### variance

          public double variance(boolean isWholePopulation,
                                 boolean... ignoreInvalids)

      Description copied from interface: `Dataset`
      The sample variance can be calculated in two ways: if the dataset is considered as the entire population then the sample variance is simply the second central moment:

              sum((x_i - m)^2)/N
           where {x_i} are set of N population values and m is the mean
              m = sum(x_i)/N

      Otherwise, if the dataset is a set of samples (with replacement) from the population then

              sum((x_i - m)^2)/(N-1)
           where {x_i} are set of N sample values and m is the unbiased estimate of the mean
              m = sum(x_i)/N

      Note that the second definition is also the unbiased estimator of population variance.
      Specified by:
        `variance` in interface `Dataset`
      Overrides:
        `variance` in class `AbstractDataset`
      Parameters:
        `isWholePopulation` - if false, consider as sample of population
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        sample variance

    - #### variance

          public CompoundDataset variance(int axis)

      Specified by:
        `variance` in interface `CompoundDataset`
      Specified by:
        `variance` in interface `Dataset`
      Overrides:
        `variance` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
      Returns:
        sample variance along axis in dataset
      See Also:
        `with isWholePopulation = false`

    - #### variance

          public CompoundDataset variance(int axis,
                                          boolean isWholePopulation,
                                          boolean... ignoreInvalids)

      Specified by:
        `variance` in interface `CompoundDataset`
      Specified by:
        `variance` in interface `Dataset`
      Overrides:
        `variance` in class `AbstractDataset`
      Parameters:
        `axis` - to reduce along
        `isWholePopulation` - if false, consider as sample of population
        `ignoreInvalids` - - see `Dataset.max(int, boolean...)`
      Returns:
        sample variance along axis in dataset

    - #### rootMeanSquare

          public double rootMeanSquare(boolean... ignoreInvalids)

      Specified by:
        `rootMeanSquare` in interface `Dataset`
      Overrides:
        `rootMeanSquare` in class `AbstractDataset`
      Parameters:
        `ignoreInvalids` - - see `IDataset.max(boolean...)`
      Returns:
        root mean square

    - #### getErrors

          public CompoundDataset getErrors()

      Description copied from interface: `ILazyDataset`
      Get the errors, if any. These will be in a shape that can broadcast to the dataset
      Specified by:
        `getErrors` in interface `CompoundDataset`
      Specified by:
        `getErrors` in interface `Dataset`
      Specified by:
        `getErrors` in interface `IDataset`
      Specified by:
        `getErrors` in interface `ILazyDataset`
      Overrides:
        `getErrors` in class `AbstractDataset`
      Returns:
        errors

    - #### getError

          public double getError(int i)

      Description copied from interface: `Dataset`
      Get the error for given position. The dataset must be 1D
      Specified by:
        `getError` in interface `Dataset`
      Overrides:
        `getError` in class `AbstractDataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        error value (symmetric)

    - #### getError

          public double getError(int i,
                                 int j)

      Description copied from interface: `Dataset`
      Get the error for given position. The dataset must be 2D
      Specified by:
        `getError` in interface `Dataset`
      Overrides:
        `getError` in class `AbstractDataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        error value (symmetric)

    - #### getError

          public double getError(int... pos)

      Description copied from interface: `IDataset`
      Get the error for a given position.
      Specified by:
        `getError` in interface `IDataset`
      Overrides:
        `getError` in class `AbstractDataset`
      Parameters:
        `pos` - position
      Returns:
        error value (symmetric)

    - #### getErrorArray

          public double[] getErrorArray(int i)

      Description copied from interface: `Dataset`
      Get the error values for given position
      Specified by:
        `getErrorArray` in interface `Dataset`
      Overrides:
        `getErrorArray` in class `AbstractDataset`
      Parameters:
        `i` - position in first dimension
      Returns:
        the values of the error at this point (can be null when no error defined)

    - #### getErrorArray

          public double[] getErrorArray(int i,
                                        int j)

      Description copied from interface: `Dataset`
      Get the error values for given position
      Specified by:
        `getErrorArray` in interface `Dataset`
      Overrides:
        `getErrorArray` in class `AbstractDataset`
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        the values of the error at this point (can be null when no error defined)

    - #### getErrorArray

          public double[] getErrorArray(int... pos)

      Description copied from interface: `IDataset`
      Get the error values for a single point in the dataset
      Specified by:
        `getErrorArray` in interface `IDataset`
      Overrides:
        `getErrorArray` in class `AbstractDataset`
      Parameters:
        `pos` - position
      Returns:
        the values of the error at this point (can be null when no error defined)

Copyright © 2014–2022 Eclipse Foundation. All rights reserved.